## 第四章 用Git+R管理项目

### 4.1 为什么要用Git+R

#### 4.1.1 当前科研项目管理中存在的问题

#### 4.1.2 Git能提供什么

#### 4.1.3 R能提供什么

#### 4.1.2 Git+R能带来什么好处

### 4.2 Git工作流

#### 4.2.1 什么是Git工作流

#### 4.2.2 本地工作流

#### 4.2.3 团队工作流

#### 4.2.4 团队工作流模型

### 4.3 科研项目工作流

#### 4.3.1 团队协作与分工

#### 4.3.2 工作流程

#### 4.3.3 数据分析工作流

#### 4.3.4 组成对象的抽象化

人、计算机、传感器、分析和监测仪器、数据库都是对象，在git系统中都是一个文件。

### 4.4 GitR的系统架构

#### 4.4.1 哲学基础

主体思想，独立、共享、协作，群众路线，

#### 4.4.2 规则体系

#### 4.4.2.1 项目管理约定

#### 4.4.2.2 数据格式

#### 4.4.2.3 文档结构及样式标准

#### 4.4.2.4 共享协议

#### 4.4.3 硬件组成

#### 4.4.4 软件及功能

#### 4.4.5 共享协作的精神

### 4.5 举个例子

#### 4.5.1 项目简介

项目的目的是实现农田数据采集的自动化，通过图像序列特征分析，找到能够描述作物群体生长状况的特征集，用这些特征集表征土壤的生产力，通过给作物号脉，调和作物和土壤的阴阳，实现“计算机看苗施肥”，取代测土配方。测土配方是间接的决策方式，成本高，效果不好。

#### 4.5.2 系统结构

#### 4.5.3 数据采集系统

#### 4.5.4 数据预处理

#### 4.5.5 数据分析

#### 4.5.6 数据发布

#### 4.5.7 监测报告

#### 4.5.8 当前进展

#### 4.5.9 可能的扩展

智能盆栽试验

大田监测

温室监测，温室数据采集机器人

